<script lang="ts">
  import { onMount } from 'svelte';
  import highcharts from '../../highcharts';
  import { build_hc_series, configureChart } from './chartConfig';
  import type { Scores } from '@models/ScoreChart';
  import { ScoresQuery } from '@models/ScoreChart';
  import { Gql } from '../../db';
  import type { Team } from '@models/Team';
  import { KeycloakStore, KeycloakInterface } from '@auth/keycloak';
  import { getScoreboardTeams } from '@queries/Team';

  let config = undefined;
  let disposeScoresSocket;
  let teams: Array<Team> = Array<Team>();
  let authenticated: boolean = false;
  let keycloak: KeycloakInterface | undefined;

  KeycloakStore.subscribe(async (value) => {
    keycloak = value.keycloak;
    // If authentication status changed, setup teams again
    const authChanged = keycloak?.authenticated !== authenticated;
    authenticated = !!keycloak?.authenticated;

    if (authenticated && authChanged) {
      const teamsLen = teams.length || 0;
      teams = await getScoreboardTeams();
      if (teams.length !== teamsLen) {
        await initialize();
      }
    }
  });

  onMount(async () => {
    // todo if we authenticate before this line is called, we'll probably never update because
    //      keycloak.subscribe callback won't happen
    teams = await getScoreboardTeams();
    await initialize();
  });

  async function initialize() {
    const sink = {
      complete: () => console.debug('subscription stopped'),
      error: (err) => console.error(err),
      next: (res: { data: { scoreboard_score: Scores } }) => {
        updateChart(res.data.scoreboard_score);
      },
    };

    let team_ids = null;
    if (teams.length > 0) {
      team_ids = teams.map((t) => t.id);
    }
    // Get the highest privileged role this user has
    const queryRole = keycloak?.getHighestPrivilegeRole();
    disposeScoresSocket = Gql.subscribe(`subscription ${ScoresQuery()}`, sink, { role: queryRole });
  }

  function updateChart(scores) {
    const teamNames = scores.map((e) => e.team.name);
    const series = build_hc_series(scores);
    config = configureChart(series, teamNames);
  }
</script>

<!-- Prevent the chart from rendering before it has config data -->
{#if config !== undefined}
  <div class="fullscreen" use:highcharts={config} />
{:else}
  <!-- this block renders when config hasn't been set yet -->
  <p>loading...</p>
{/if}
